map S32 Request_Header as input 0x2400:01
map S32 Request_Value as input 0x2400:02
map S32 Answer_Header as output 0x2500:01
map S32 Answer_Value as output 0x2500:02

#include "wrapper.h"

	U08 Request_Info;
	U16 Index;
	U08 SubIndex;
	U16 Request_Address;	
	bool Toggle_Bit;
	bool Write_Bit;	
	bool oldToggle_Bit;	
	U16 Address;

void Config_PDOs()	//sets up the PDO-Mapping between the Master and the Slave
{
	if(od_read(0x1F80, 0x00) != 0x08)
	{	
		od_write(0x1400, 0x01, (od_read(0x1400, 0x01) | 0x80000000));
		od_write(0x1401, 0x01, (od_read(0x1401, 0x01) | 0x80000000));
		od_write(0x1402, 0x01, (od_read(0x1402, 0x01) | 0x80000000));
		od_write(0x1403, 0x01, (od_read(0x1403, 0x01) | 0x80000000));
		yield();
		od_write(0x1404, 0x01, (od_read(0x1404, 0x01) | 0x80000000));
		od_write(0x1405, 0x01, (od_read(0x1405, 0x01) | 0x80000000));
		od_write(0x1406, 0x01, (od_read(0x1406, 0x01) | 0x80000000));
		od_write(0x1407, 0x01, (od_read(0x1407, 0x01) | 0x80000000));	
		yield();
		od_write(0x1800, 0x01, (od_read(0x1800, 0x01) | 0x80000000));
		od_write(0x1801, 0x01, (od_read(0x1801, 0x01) | 0x80000000));
		od_write(0x1802, 0x01, (od_read(0x1802, 0x01) | 0x80000000));
		od_write(0x1803, 0x01, (od_read(0x1803, 0x01) | 0x80000000));
		yield();
		od_write(0x1804, 0x01, (od_read(0x1804, 0x01) | 0x80000000));
		od_write(0x1805, 0x01, (od_read(0x1805, 0x01) | 0x80000000));
		od_write(0x1806, 0x01, (od_read(0x1806, 0x01) | 0x80000000));
		od_write(0x1807, 0x01, (od_read(0x1807, 0x01) | 0x80000000));	
		yield();
		od_write(0x1604, 0x00, 0x00);
		od_write(0x1A04, 0x00, 0x00);	
		od_write(0x1404, 0x02, 0xFF);
		od_write(0x1804, 0x02, 0xFF);	
		od_write(0x1804, 0x03, 0x64);	
		yield();
		od_write(0x1604, 0x01, 0x24000120);
		od_write(0x1604, 0x02, 0x24000220);	
		od_write(0x1604, 0x00, 0x02);
		yield();	
		od_write(0x1A04, 0x01, 0x25000120);
		od_write(0x1A04, 0x02, 0x25000220);	
		od_write(0x1A04, 0x00, 0x02);	
		yield();
		od_write(0x1404, 0x01, 0x222);	
		od_write(0x1804, 0x01, 0x333);
		od_write(0x1F80, 0x00, 0x08);
		yield();	
		od_write(0x1010, 0x02, 0x65766173);
		yield();
		while(od_read(0x1010, 0x02)!= 0x01)
		{
			yield();
		}
		od_write(0x2800, 0x01, 0x746F6F62);		
		yield();	
	}				
}

void Unpack_Request_Header()	//splits the values recieved by the PDO into its meanings
{
	SubIndex		=	(In.Request_Header & 0x000000FFu);			
	Index			=	(In.Request_Header & 0x00FFFF00u) >> 8u;		
	Request_Address	=	(In.Request_Header & 0x3F000000u) >> 24u;
	Request_Info	=	(In.Request_Header & 0xC0000000u) >> 28u;								
	Write_Bit		= 	(Request_Info & 0b0100u);			
	Toggle_Bit		= 	(Request_Info & 0b1000u);	
	
}	

void Handle_Request()		//processes the request from the Master
{
	Unpack_Request_Header();	

	
	
	if((Request_Address == Address) && (oldToggle_Bit != Toggle_Bit))
	{
		if(Write_Bit)
		{
			od_write(Index, SubIndex, In.Request_Value);
			Out.Answer_Value = 0;
			Out.Answer_Header = In.Request_Header;
		}
		else
		{
			Out.Answer_Value = od_read(Index, SubIndex);
			Out.Answer_Header = In.Request_Header;				
		}	
		oldToggle_Bit = Toggle_Bit;
			
	}

	if(Request_Address == 1)
	{
		oldToggle_Bit = false;
	}		
}

void user()
{
	Config_PDOs();
	oldToggle_Bit = false;
	Address = od_read(0x2009, 0x00);	
	
	while(true)
	{	
		Handle_Request();	
		yield();
	}	
}
